-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Filter Builder - Customization
In this demo, a custom filter operation, "anyof", is implemented. The calculateFilterExpression function converts it into DataSource-compatible operations. The compatible and incompatible filter expressions are displayed under the JavaScript FilterBuilder.
The set of available group operations is limited to "and" and "or" using the groupOperations array, and the groups’ maximum nesting level is limited to one using the maxGroupLevel.
Backend API
$(() => {
$('#filterBuilder').dxFilterBuilder({
fields,
value: filter,
maxGroupLevel: 1,
groupOperations: ['and', 'or'],
onValueChanged: updateTexts,
onInitialized: updateTexts,
customOperations: [{
name: 'anyof',
caption: 'Is any of',
icon: 'check',
editorTemplate(conditionInfo) {
return $('<div>').dxTagBox({
value: conditionInfo.value,
items: categories,
inputAttr: { 'aria-label': 'Category' },
onValueChanged(e) {
conditionInfo.setValue(e.value && e.value.length ? e.value : null);
},
width: 'auto',
});
},
calculateFilterExpression(filterValue, field) {
return filterValue && filterValue.length
&& Array.prototype.concat.apply([], filterValue.map((value) => [[field.dataField, '=', value], 'or'])).slice(0, -1);
},
}],
});
function updateTexts(e) {
$('#filterText').text(formatValue(e.component.option('value')));
$('#dataSourceText').text(formatValue(e.component.getFilterExpression()));
}
function formatValue(value, spaces = TAB_SIZE) {
if (value && Array.isArray(value[0])) {
return `[${getLineBreak(spaces)}${value.map((item) => (Array.isArray(item[0]) ? formatValue(item, spaces + TAB_SIZE) : JSON.stringify(item))).join(`,${getLineBreak(spaces)}`)}${getLineBreak(spaces - TAB_SIZE)}]`;
}
return JSON.stringify(value);
}
function getLineBreak(spaces) {
return `\r\n${new Array(spaces + 1).join(' ')}`;
}
});
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<script src="https://cdn.jsdelivr.net/npm/cldrjs@0.5.5/dist/cldr.js"></script>
<script src="https://cdn.jsdelivr.net/npm/cldrjs@0.5.5/dist/cldr/event.js"></script>
<script src="https://cdn.jsdelivr.net/npm/cldrjs@0.5.5/dist/cldr/supplemental.js"></script>
<script src="https://cdn.jsdelivr.net/npm/cldrjs@0.5.5/dist/cldr/unresolved.js"></script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script src="js/dx.all.js?v=26.1.3"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="data.js"></script>
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="filterBuilder"></div>
<div class="results">
<div>
<b>Value</b>
<pre id="filterText"></pre>
</div>
<div>
<b>DataSource's filter expression</b>
<pre id="dataSourceText"></pre>
</div>
</div>
</div>
</body>
</html>
.results {
margin-top: 50px;
display: flex;
justify-content: space-between;
}
.results > div {
flex-basis: 49%;
max-width: 50%;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.results b {
position: absolute;
top: -25px;
}
.results pre {
padding: 10px 20px;
height: 100%;
font-size: 13px;
overflow: auto;
box-sizing: border-box;
}
.dx-tagbox {
min-width: 150px;
}
.dx-filterbuilder {
background-color: transparent;
box-shadow: 0 8px 16px 0 rgba(0, 0, 0, 0.14), 0 0 2px 0 rgba(0, 0, 0, 0.12);
border-radius: 6px;
padding: 15px;
margin: 24px;
}
.dx-filterbuilder .dx-numberbox {
width: 80px;
}
const filter = [
['Category', 'anyof', ['Automation', 'Monitors']],
'or',
[
['Category', '=', 'Televisions'],
'and',
['Price', 'between', [2000, 4000]],
],
];
const categories = [
'Video Players',
'Televisions',
'Monitors',
'Projectors',
'Automation',
];
const fields = [{
dataField: 'Name',
}, {
dataField: 'Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Current_Inventory',
dataType: 'number',
caption: 'Inventory',
}, {
dataField: 'Category',
filterOperations: ['=', 'anyof'],
lookup: {
dataSource: categories,
},
},
];
const TAB_SIZE = 4;

DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Vue Filter Builder - Customization

In this demo, a custom filter operation, "anyof", is implemented. The calculateFilterExpression function converts it into DataSource-compatible operations. The compatible and incompatible filter expressions are displayed under the FilterBuilder.

The set of available group operations is limited to "and" and "or" using the groupOperations array, and the groups’ maximum nesting level is limited to one using the maxGroupLevel.

Backend API
<template> <div> <DxFilterBuilder :fields="fields" :value="filter" :group-operations="groupOperations" @initialized="updateTexts" @value-changed="updateTexts" > <DxCustomOperation :calculate-filter-expression="calculateFilterExpression" name="anyof" caption="Is any of" icon="check" editor-template="editorComponentTemplate" /> <template #editorComponentTemplate="{ data: conditionInfo }"> <EditorComponent :condition-info="conditionInfo"/> </template> </DxFilterBuilder> <div class="results"> <div> <b>Value</b> <pre>{{ filterText }}</pre> </div> <div> <b>DataSource&apos;s filter expression</b> <pre>{{ dataSourceText }}</pre> </div> </div> </div> </template> <script setup lang="ts"> import { ref } from 'vue'; import DxFilterBuilder, { DxCustomOperation, type DxFilterBuilderTypes } from 'devextreme-vue/filter-builder'; import { filter, fields } from './data.ts'; import { formatValue } from './helpers.ts'; import EditorComponent from './EditorComponent.vue'; const filterText = ref(''); const groupOperations: DxFilterBuilderTypes.GroupOperation[] = ['and', 'or']; const dataSourceText = ref(''); function updateTexts(e: DxFilterBuilderTypes.InitializedEvent) { filterText.value = formatValue(e.component?.option('value') || ''); dataSourceText.value = formatValue(e.component?.getFilterExpression() || ''); } function calculateFilterExpression(filterValue: any, field: DxFilterBuilderTypes.Field) { return filterValue?.length && Array.prototype.concat.apply([], filterValue.map((value: any) => [[field.dataField, '=', value], 'or'])).slice(0, -1); } </script> <style scoped> .results { margin-top: 50px; display: flex; justify-content: space-between; } .results > div { flex-basis: 49%; max-width: 50%; background-color: rgba(191, 191, 191, 0.15); position: relative; } .results b { position: absolute; top: -25px; } .results pre { padding: 10px 20px; height: 100%; font-size: 13px; overflow: auto; box-sizing: border-box; } .dx-tagbox { min-width: 150px; } .dx-filterbuilder { background-color: transparent; box-shadow: 0 8px 16px 0 rgba(0, 0, 0, 0.14), 0 0 2px 0 rgba(0, 0, 0, 0.12); border-radius: 6px; padding: 15px; margin: 24px; } .dx-filterbuilder .dx-numberbox { width: 80px; } </style>
<template> <DxTagBox :value="conditionInfo.value" :items="categories" :input-attr="{ 'aria-label': 'Category' }" width="auto" @value-changed="onValueChanged" /> </template> <script setup lang="ts"> import DxTagBox, { type DxTagBoxTypes } from 'devextreme-vue/tag-box'; import { categories } from './data.ts'; const props = withDefaults(defineProps<{ conditionInfo?: Record<string, any> }>(), { conditionInfo: () => ({} as Record<string, any>), }); function onValueChanged(e: DxTagBoxTypes.ValueChangedEvent) { props.conditionInfo.setValue(e.value && e.value.length ? e.value : null); } </script>
window.exports = window.exports || {}; window.config = { transpiler: false, meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'typescript': { 'exports': 'ts', }, 'vue': { format: 'global', exports: 'Vue', esModule: true, }, 'vuex': { format: 'global', exports: 'Vuex', esModule: true, }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, 'zod': { 'esModule': true, }, 'zod-to-json-schema': { 'esModule': true, }, 'anti-forgery': { loader: 'demo-ts-loader', }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', 'loaders:': '../../../../shared/loaders/', }, map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'vue': 'npm:vue@3.5.32/dist/vue.global.js', '@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js', 'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js', 'demo-ts-loader': 'loaders:demo-ts-loader.js', 'demo-ts-shared': 'loaders:demo-ts-shared.js', 'vue-loader': 'loaders:demo-vue-loader.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'svg-loader': 'project:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs', 'zod': 'externals:zod.bundle.js', 'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js', 'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme-vue/common': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai']; let packagesInfo = { "zod": { "version": "3.24.4" }, "zod-to-json-schema": { "version": "3.24.6" } };
import { type DxFilterBuilderTypes } from 'devextreme-vue/filter-builder'; export const filter = [ ['Category', 'anyof', ['Automation', 'Monitors']], 'or', [ ['Category', '=', 'Televisions'], 'and', ['Price', 'between', [2000, 4000]], ], ]; export const categories = [ 'Video Players', 'Televisions', 'Monitors', 'Projectors', 'Automation', ]; export const fields: DxFilterBuilderTypes.Field[] = [{ dataField: 'Name', }, { dataField: 'Price', dataType: 'number', format: 'currency', }, { dataField: 'Current_Inventory', dataType: 'number', caption: 'Inventory', }, { dataField: 'Category', filterOperations: ['=', 'anyof'], lookup: { dataSource: categories, }, }];
const TAB_SIZE = 4; export function formatValue(value: string | Function | any[], spaces = TAB_SIZE): string { if (value && Array.isArray(value) && Array.isArray(value[0])) { return `[${getLineBreak(spaces)}${value.map((item) => (Array.isArray(item[0]) ? formatValue(item, spaces + TAB_SIZE) : JSON.stringify(item))).join(`,${getLineBreak(spaces)}`)}${getLineBreak(spaces - TAB_SIZE)}]`; } return JSON.stringify(value); } function getLineBreak(spaces: number) { return `\r\n${new Array(spaces + 1).join(' ')}`; }
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <script type="module"> import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>

Backend API
<dx-filter-builder
[fields]="fields"
[(value)]="filter"
[groupOperations]="groupOperations"
[customOperations]="customOperations"
(onInitialized)="updateTexts($event)"
(onValueChanged)="updateTexts($event)"
>
<dx-tag-box
*dxTemplate="let condition of 'tagBoxTemplate'"
[value]="condition.value"
[items]="categories"
[inputAttr]="{ 'aria-label': 'Category' }"
(onValueChanged)="condition.setValue($event.value)"
width="auto"
>
</dx-tag-box>
</dx-filter-builder>
<div class="results">
<div>
<b>Value</b>
<pre>{{ filterText }}</pre>
</div>
<div>
<b>DataSource's filter expression</b>
<pre>{{ dataSourceText }}</pre>
</div>
</div>
import { ChangeDetectionStrategy, Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { DxListModule, DxButtonModule, DxTagBoxModule } from 'devextreme-angular';
import { DxFilterBuilderModule, DxFilterBuilderComponent, DxFilterBuilderTypes } from 'devextreme-angular/ui/filter-builder';
import { Service } from './app.service';
type FilterBuilderValue = ReturnType<DxFilterBuilderComponent['instance']['getFilterExpression']>;
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
const anyOfOperation = {
name: 'anyof',
caption: 'Is any of',
icon: 'check',
editorTemplate: 'tagBoxTemplate',
calculateFilterExpression: (filterValue: string[], field: Record<string, unknown>) => filterValue?.flatMap(
(value) => [[field.dataField, '=', value], 'or'],
).slice(0, -1),
} as const;
const TAB_SIZE = 4;
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
changeDetection: ChangeDetectionStrategy.Eager,
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxListModule,
DxButtonModule,
DxTagBoxModule,
DxFilterBuilderModule,
],
})
export class AppComponent {
filterText: string;
dataSourceText: string;
fields: string[];
filter: (string[] | string)[];
categories: string[];
customOperations: typeof anyOfOperation[] = [anyOfOperation];
groupOperations = ['and', 'or'];
constructor(service: Service) {
this.fields = service.getFields();
this.filter = service.getFilter();
this.categories = service.getCategories();
}
updateTexts(e: DxFilterBuilderTypes.InitializedEvent) {
this.filterText = AppComponent.formatValue(e.component.option('value'));
this.dataSourceText = AppComponent.formatValue(e.component.getFilterExpression());
}
private static formatValue(value: FilterBuilderValue, spaces = TAB_SIZE) {
if (value && Array.isArray(value[0])) {
return `[${AppComponent.getLineBreak(spaces)}${
(value as string[]).map(
(item: FilterBuilderValue) => (Array.isArray(item[0])
? AppComponent.formatValue(item, spaces + TAB_SIZE)
: JSON.stringify(item)),
).join(`,${AppComponent.getLineBreak(spaces)}`)
}${AppComponent.getLineBreak(spaces - TAB_SIZE)}]`;
}
return JSON.stringify(value);
}
private static getLineBreak = (spaces: number) => `\r\n${new Array(spaces + 1).join(' ')}`;
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .results {
margin-top: 50px;
display: flex;
justify-content: space-between;
}
::ng-deep .results > div {
flex-basis: 49%;
max-width: 50%;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
::ng-deep .results b {
position: absolute;
top: -25px;
}
::ng-deep .results pre {
padding: 10px 20px;
height: 100%;
font-size: 13px;
overflow: auto;
box-sizing: border-box;
}
::ng-deep .dx-tagbox {
min-width: 150px;
}
::ng-deep .dx-filterbuilder {
background-color: transparent;
box-shadow: 0 8px 16px 0 rgba(0, 0, 0, 0.14), 0 0 2px 0 rgba(0, 0, 0, 0.12);
border-radius: 6px;
padding: 15px;
margin: 24px;
}
::ng-deep .dx-filterbuilder .dx-numberbox {
width: 80px;
}
import { Injectable } from '@angular/core';
export class Product {
ID: number;
Name: string;
Price: number;
Current_Inventory: number;
Backorder: number;
Manufacturing: number;
Category: string;
ImageSrc: string;
}
const filter: any[] = [
['Category', 'anyof', ['Automation', 'Monitors']],
'or',
[
['Category', '=', 'Televisions'],
'and',
['Price', 'between', [2000, 4000]],
],
];
const categories: string[] = [
'Video Players',
'Televisions',
'Monitors',
'Projectors',
'Automation',
];
const fields: any[] = [{
dataField: 'Name',
}, {
dataField: 'Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Current_Inventory',
dataType: 'number',
caption: 'Inventory',
}, {
dataField: 'Category',
filterOperations: ['=', 'anyof'],
lookup: {
dataSource: categories,
},
},
];
@Injectable()
export class Service {
getFields(): any[] {
return fields;
}
getCategories(): string[] {
return categories;
}
getFilter(): any[] {
return filter;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'demo-ts-shared': 'project:utils/demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

Backend API
import React, { useCallback, useState } from 'react';
import FilterBuilder, { CustomOperation } from 'devextreme-react/filter-builder';
import type { FilterBuilderTypes, ICustomOperationProps } from 'devextreme-react/filter-builder';
import { filter, fields, groupOperations } from './data.ts';
import { formatValue } from './helpers.ts';
import { EditorComponent } from './EditorComponent.tsx';
function App() {
const [value, setValue] = useState(filter);
const [filterText, setFilterText] = useState('');
const [dataSourceText, setDataSourceText] = useState('');
const updateTexts = useCallback((e: FilterBuilderTypes.InitializedEvent) => {
setFilterText(formatValue(e.component?.option('value')));
setDataSourceText(formatValue(e.component?.getFilterExpression()));
}, []);
const onValueChanged = useCallback((e: FilterBuilderTypes.ValueChangedEvent) => {
setValue(e.value);
updateTexts(e);
}, [updateTexts]);
const calculateFilterExpression: ICustomOperationProps['calculateFilterExpression'] = useCallback((filterValue, field) => (
filterValue?.length
&& Array.prototype.concat
.apply(
[],
filterValue.map((i: string) => [[field.dataField, '=', i], 'or']),
)
.slice(0, -1)
), []);
return (
<div>
<FilterBuilder
fields={fields}
value={value}
onInitialized={updateTexts}
groupOperations={groupOperations}
onValueChanged={onValueChanged}
>
<CustomOperation
name="anyof"
caption="Is any of"
icon="check"
editorComponent={EditorComponent}
calculateFilterExpression={calculateFilterExpression}
/>
</FilterBuilder>
<div className="results">
<div>
<b>Value</b>
<pre>{filterText}</pre>
</div>
<div>
<b>DataSource's filter expression</b>
<pre>{dataSourceText}</pre>
</div>
</div>
</div>
);
}
export default App;
import React, { useCallback, useState } from 'react';
import FilterBuilder, { CustomOperation } from 'devextreme-react/filter-builder';
import { filter, fields, groupOperations } from './data.js';
import { formatValue } from './helpers.js';
import { EditorComponent } from './EditorComponent.js';
function App() {
const [value, setValue] = useState(filter);
const [filterText, setFilterText] = useState('');
const [dataSourceText, setDataSourceText] = useState('');
const updateTexts = useCallback((e) => {
setFilterText(formatValue(e.component?.option('value')));
setDataSourceText(formatValue(e.component?.getFilterExpression()));
}, []);
const onValueChanged = useCallback(
(e) => {
setValue(e.value);
updateTexts(e);
},
[updateTexts],
);
const calculateFilterExpression = useCallback(
(filterValue, field) =>
filterValue?.length &&
Array.prototype.concat
.apply(
[],
filterValue.map((i) => [[field.dataField, '=', i], 'or']),
)
.slice(0, -1),
[],
);
return (
<div>
<FilterBuilder
fields={fields}
value={value}
onInitialized={updateTexts}
groupOperations={groupOperations}
onValueChanged={onValueChanged}
>
<CustomOperation
name="anyof"
caption="Is any of"
icon="check"
editorComponent={EditorComponent}
calculateFilterExpression={calculateFilterExpression}
/>
</FilterBuilder>
<div className="results">
<div>
<b>Value</b>
<pre>{filterText}</pre>
</div>
<div>
<b>DataSource's filter expression</b>
<pre>{dataSourceText}</pre>
</div>
</div>
</div>
);
}
export default App;
import React, { useCallback } from 'react';
import TagBox, { type TagBoxTypes } from 'devextreme-react/tag-box';
import { categories, categoryLabel } from './data.ts';
export const EditorComponent = (props: { data: { value: any, setValue: (value: any) => void } }) => {
const onValueChanged = useCallback((e: TagBoxTypes.ValueChangedEvent) => {
props.data.setValue(e.value?.length ? e.value : null);
}, [props.data]);
return (
<TagBox
inputAttr={categoryLabel}
defaultValue={props.data.value}
items={categories}
onValueChanged={onValueChanged}
width="auto"
/>
);
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { FilterBuilderTypes } from 'devextreme-react/filter-builder';
export const filter = [
['Category', 'anyof', ['Automation', 'Monitors']],
'or',
[
['Category', '=', 'Televisions'],
'and',
['Price', 'between', [2000, 4000]],
],
];
export const categories = [
'Video Players',
'Televisions',
'Monitors',
'Projectors',
'Automation',
];
export const groupOperations: FilterBuilderTypes.GroupOperation[] = ['and', 'or'];
export const fields: FilterBuilderTypes.Field[] = [{
dataField: 'Name',
}, {
dataField: 'Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Current_Inventory',
dataType: 'number',
caption: 'Inventory',
}, {
dataField: 'Category',
filterOperations: ['=', 'anyof'],
lookup: {
dataSource: categories,
},
}];
export const categoryLabel = { 'aria-label': 'Category' };
import type { FilterBuilderTypes } from 'devextreme-react/filter-builder';
type FilterValue = FilterBuilderTypes.Properties['value'];
const TAB_SIZE = 4;
function prepareItem(item: FilterValue, spaces: number): string {
return Array.isArray(item) && Array.isArray(item[0])
? formatValue(item, spaces + TAB_SIZE)
: JSON.stringify(item);
}
export function formatValue(value: FilterValue, spaces: number = TAB_SIZE): string {
if (value && Array.isArray(value) && Array.isArray(value[0])) {
const formattedValue = value
.map((item) => prepareItem(item, spaces))
.join(`,${getLineBreak(spaces)}`);
return `[${getLineBreak(spaces)}${formattedValue}${getLineBreak(spaces - TAB_SIZE)}]`;
}
return JSON.stringify(value);
}
function getLineBreak(spaces: number) {
return `\r\n${new Array(spaces + 1).join(' ')}`;
}
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React, { useCallback } from 'react';
import TagBox from 'devextreme-react/tag-box';
import { categories, categoryLabel } from './data.js';
export const EditorComponent = (props) => {
const onValueChanged = useCallback(
(e) => {
props.data.setValue(e.value?.length ? e.value : null);
},
[props.data],
);
return (
<TagBox
inputAttr={categoryLabel}
defaultValue={props.data.value}
items={categories}
onValueChanged={onValueChanged}
width="auto"
/>
);
};
const TAB_SIZE = 4;
function prepareItem(item, spaces) {
return Array.isArray(item) && Array.isArray(item[0])
? formatValue(item, spaces + TAB_SIZE)
: JSON.stringify(item);
}
export function formatValue(value, spaces = TAB_SIZE) {
if (value && Array.isArray(value) && Array.isArray(value[0])) {
const formattedValue = value
.map((item) => prepareItem(item, spaces))
.join(`,${getLineBreak(spaces)}`);
return `[${getLineBreak(spaces)}${formattedValue}${getLineBreak(spaces - TAB_SIZE)}]`;
}
return JSON.stringify(value);
}
function getLineBreak(spaces) {
return `\r\n${new Array(spaces + 1).join(' ')}`;
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const filter = [
['Category', 'anyof', ['Automation', 'Monitors']],
'or',
[['Category', '=', 'Televisions'], 'and', ['Price', 'between', [2000, 4000]]],
];
export const categories = ['Video Players', 'Televisions', 'Monitors', 'Projectors', 'Automation'];
export const groupOperations = ['and', 'or'];
export const fields = [
{
dataField: 'Name',
},
{
dataField: 'Price',
dataType: 'number',
format: 'currency',
},
{
dataField: 'Current_Inventory',
dataType: 'number',
caption: 'Inventory',
},
{
dataField: 'Category',
filterOperations: ['=', 'anyof'],
lookup: {
dataSource: categories,
},
},
];
export const categoryLabel = { 'aria-label': 'Category' };
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.results {
margin-top: 50px;
display: flex;
justify-content: space-between;
}
.results > div {
flex-basis: 49%;
max-width: 50%;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.results b {
position: absolute;
top: -25px;
}
.results pre {
padding: 10px 20px;
height: 100%;
font-size: 13px;
overflow: auto;
box-sizing: border-box;
}
.dx-tagbox {
min-width: 150px;
}
.dx-filterbuilder {
background-color: transparent;
box-shadow: 0 8px 16px 0 rgba(0, 0, 0, 0.14), 0 0 2px 0 rgba(0, 0, 0, 0.12);
border-radius: 6px;
padding: 15px;
margin: 24px;
}
.dx-filterbuilder .dx-numberbox {
width: 80px;
}